//     cache-control.js
//     (c) 2013-2013 Seaman Jiang / Digital Heaven

(function(hui, undefined) {
	hui.csdn = function() {
	}
	var L = hui.MyWidget.NLocal;

	hui.extend(hui.csdn.prototype, {
		DB_Name: 'csdn_local_db',
		DB_VERSION: '',
		jsonp_Server: 'http://csdnnewsappcomm.csdn.net/',
		mk_Server: 'http://csdnnewsapp.csdn.net/',
		timeout : 30000, //ajax请求的超时时间
		cacheKey : {
			fontSize : "CSDN_FontSize",
			push : "CSDN_Push",
			noImage : "CSDN_NoImage",
			userName : "CSDN_USERNAME",
			password : "CSDN_password",
			articleId : "CSDN_articleId",
			articleUrl : "CSDN_articleUrl",
			articleTitle : "CSDN_articleTitle",
			shareType : "CSDN_sharetype", //qq或sina
			updateTime : "CSDN_updatetime", //列表第一页的更新时间
			tiro : "CSDN_tiro", //新手指导标志
			articleContent : "CSDN_articleContent",
			widgtPath:'CSDN_widgtPath',
			releaseNotes: 'CSDN_releasenotes'
		},
		is2GOr3G : function() {
			if (!plus.networkinfo) {
				//alert("基座版本不对");
				return true;
			}
			var type = plus.networkinfo.getCurrentType();
			return type == plus.networkinfo.CONNECTION_CELL2G || type == plus.networkinfo.CONNECTION_CELL3G || type == plus.networkinfo.CONNECTION_CELL4G;
		},
		is2G : function() {
			if (!plus.networkinfo) {
				//alert("基座版本不对");
				return true;
			}
			var type = plus.networkinfo.getCurrentType();
			return type == plus.networkinfo.CONNECTION_CELL2G;
		},
		hasNetwork : function() {
			if (!plus.networkinfo) {
				//alert("基座版本不对");
				return true;
			};
			
			var type = plus.networkinfo.getCurrentType(), networkInfo = plus.networkinfo;
			return type == networkInfo.CONNECTION_ETHERNET || type == networkInfo.CONNECTION_WIFI || type == networkInfo.CONNECTION_CELL2G || type == networkInfo.CONNECTION_CELL3G || type == networkInfo.CONNECTION_CELL4G;
		},
		customerFontSize : {
			"大" : "1.5em",
			"中" : "1.3em",
			"小" : "1.15em"
		},
		getFontSize : function() {
			var fontsize = L.getItem(this.cacheKey.fontSize)|| {text : "中",	value : "1.3em"};
			return fontsize;
		},
		setFontSize : function(value) {
			L.setItem(this.cacheKey.fontSize, value);
		},
		loadCategoryByPageNetwork : function(category, pagenum, onSuccess, onError, checkFunc) {
			//var _pageNum = category == "news" ? (pagenum - 1) % 4 + 1 : pagenum;
			//最新资讯一次回来40条数据
			var time = new Date().getTime(),
				that = this;
				
			return hui.ajax({
				type : 'GET',
				timeout : that.timeout,
				url : that.jsonp_Server + 'all_list/' + category + 'list_' +  (category == 'news' ? 1: 2) +  '0_' + pagenum + '.json',
				// type of data we are expecting in return:
				dataType : 'jsonp',
				success : function(data) {
					var time_tj = new Date().getTime()-time;
					plus.statistic.eventDuration("ajax", time_tj ,category+ "_" +pagenum);
					if (pagenum == 1 && checkFunc && checkFunc(data))
						return;
					if(!data.list) onError(null, 'timeout');
					var isAndroid = that.isAndroid(), list = data.list, len = list.length, counter = 0;
					if(hui.webSQL){
						that.db.transaction(function(tx) {
							var firstnews = data.firstnews;
							if(firstnews){
								tx.executeSql('INSERT OR REPLACE into first_news values(?,?,?,?,?,?,?,?,?,?,?)', [firstnews.id,firstnews.title,firstnews.img,firstnews.ptime,firstnews.category,firstnews.href,firstnews.count,firstnews.remark,firstnews.fav,firstnews.readflag,firstnews.androidimg]);
							}
							for (var index = 0; index < len; index++) {
								that._saveNewToDb(tx, list[index], isAndroid, function(result) {
									counter++;
									if (counter == len) that.loadCategoryByPageDB(category, pagenum, onSuccess, onError);
								});
							}
						});
					}
					else if(hui.indexedDB){
						var index=0,
							indexdb = hui.indexedDB;
						if(data.firstnews){
							indexdb.put({
								name: 'first_news',
								data: data.firstnews
							});
						}
						for(; index< len; index++){
							var d = list[index];
							indexdb.add({
								name: 'article_list',
								data: d,
								onsuccess: function(e, op){
									counter++;
									if (counter == len) that.loadCategoryByPageDB(category, pagenum, onSuccess, onError);
								},
								onerror: function(e,op){
									indexdb.get({
										name: 'article_list',
										data: op.data,
										keyvalue: op.data.id,
										onsuccess: function(e, op){
											var result = e.target.result,
												_d = op.data;
											if(result){
												result.remark = _d.remark;
												result.count = _d.count;
												indexdb.put({
													name: 'article_list',
													data: result,
													onsuccess: function(e, op){
														counter++;
														if (counter == len) that.loadCategoryByPageDB(category, pagenum, onSuccess, onError);
													},
													onerror: function(e,op){
														//alert(JSON.stringify(op));
													}
												});
											}
											else{
												//alert('loadCategoryByPageNetwork err2013/6/26');
											}
										},
										error: function(e, op){
											var s = 0;
										}
									});
								}
							});
						}
					}
				},
				error : function(xhr, type, s2) {
					if(type != 'abort'){
						plus.statistic.eventDuration("ajax", new Date().getTime()-time,category+ "_" +pagenum+ "_" +type);
					}
					if (onError)
						onError(xhr, type);
					else
						that.alert("发生网络错误，请稍后重试", 2000);
				}
			});
		},
		_saveNewToDb: function(transition, data, isAndroid, onSuccess) {
			transition.executeSql('select count(id) as num from article_list where id = ?', [data.id], function(tr, result) {
				if (result.rows.item(0).num != 0) {//已存在记录，更新count和remark
					transition.executeSql('update article_list set remark=?,[count]=? where id = ?', [data.remark, parseInt(data.count, 10), data.id], function(tr, result) {
						onSuccess(result);
					});
				} else {
					//data.ptime = datenow_from_csdn_network(data.ptime);
					//if(isAndroid) data.img = data.Androidimg;
					transition.executeSql('INSERT into article_list values(?,?,?,?,?,?,?,?,0,0,?)', [data.id, data.title, data.Androidimg, data.ptime, data.category, data.href, parseInt(data.count, 10), data.remark, data.Androidimg], function(tx, result) {
						onSuccess(result);
					});
				}
			});
		},
		/**
		从本地数据库加载数据
		*/
		loadCategoryByPageDB : function(category, pagenum, onSuccess, onError) {
			var that = this,
				db = that.db;
			if(hui.webSQL){
				db.readTransaction(function(tr){
					var pagestart = 20 * (pagenum - 1), 
						pageEnd = pagestart + 20,
						latssql = "",
						sql;
					if (category == "news") {
						sql = "SELECT * FROM article_list  ORDER BY ptime DESC LIMIT " + pagestart + ", 20";
					}
					else {
						sql = "select * from article_list where category = '" + category + "' " + latssql + " order by ptime desc limit " + pagestart + ", 20"
					}
					tr.executeSql(sql, [], function(tx,rs){
						var list = [],
							rows = rs.rows,
							len = rows.length;
						if(len == 0){
							onSuccess();
							return;
						}
						for (var i = 0; i < len; i++){
							var item = rows.item(i);
							list.push({
								id: item.id,
								title: item.title,
								img: item.img,
								ptime: item.ptime,
								category: item.category,
								href: item.href,
								count: item.count,
								remark: item.remark,
								fav: item.fav,
								readflag: item.readflag,
								Androidimg: item.androidimg
							});
						}
						if (category == "news" && pagenum == 1) {
							tx.executeSql('Select * From first_news order by ptime desc Limit 1', [], function(tx, rs){
                                if (rs.rows.length > 0) {
                                    var item = rs.rows.item(0),
										firstnews = {
											id:item.id,
											title:item.title,
											img:item.img,
											ptime:item.ptime,
											count:item.count,
											remark:item.remark,
											author:item.author,
											href:item.href
										}
								}
								onSuccess({list:list, firstnews: firstnews});
                            })
						}
						else{
							onSuccess({list:list});
						}
					});
				});
			}
			else if(hui.indexedDB){
				hui.indexedDB.getList({
					name: 'article_list',
					key: category == 'news'? 'ptime' : 'category',
					keyRange: category == 'news' ? null : IDBKeyRange.only(category),
					pageIndex: pagenum,
					pageCount: 20,
					onsuccess: function(data){
						if(category != "news" || pagenum != 1){
							onSuccess({list:data});
							return;
						}
						hui.indexedDB.getList({
							name: 'first_news',
							key: 'ptime',
							pageIndex: 1,
							pageCount: 1,
							onsuccess: function(first){
								onSuccess({list:data, firstnews: first[0]});
							},
							onerror: function(e){
								onSuccess({list: data});
							}
						});
					},
					onerror: function(e){
						plus.statistic.eventTrig("error",'loadCategoryByPageDB hui.indexedDB.getList');
						//alert('loadCategoryByPageDB hui.indexedDB.getList err2013/6/26');
					}
				});
			}

		},
		init : function(callback) {
			var that = this;
			if(hui.webSQL){
				hui.webSQL.init({
					name: that.DB_Name + '_' + that.DB_VERSION,
					description: 'csdn offline database',
					onInit: function(db){
						db.transaction(function(tx) {
							tx.executeSql('create table if not exists article_list (id num PRIMARY KEY,title text, img text, ptime datetime, category text, href text, count num, remark num, fav num, readflag bit, androidimg text)', []);
							tx.executeSql('create table if not exists first_news (id num PRIMARY KEY,title text, img text, ptime datetime , category text, href text, count num, remark num, fav num, readflag bit, androidimg text)', []);
						});
					}
				});
				that.db = hui.webSQL.db;
				if(callback) callback();
			}
			else{
				if(!hui.indexedDB){
					plus.statistic.eventTrig("error",'不支持您的手机');
					return;
				}
				hui.indexedDB.init({
					name: that.DB_Name + '_' + that.DB_VERSION,
					onupgradeneeded: function(e){
						try{
						var result = e.currentTarget.result,
							list = result.createObjectStore('article_list', {keyPath: "id"}),
							firtnews = result.createObjectStore('first_news', {keyPath: "id"});
						list.createIndex('ptime', 'ptime', {unique: false});
						list.createIndex('category', 'category', {unique: false});
						list.createIndex('fav', ['fav', 'ptime'], {unique: false});
						firtnews.createIndex('ptime', 'ptime', {unique: false});
						}
						catch(ex){
							hui.showErr(ex, 'onupgradeneeded');
							throw ex;
						}
					},
					onsuccess: function(e){
						that.db = e.target.result;

						if(callback) callback();
					},
					onerror: function(){
						alert('init indexeddb error');
					}
				});
			}
		},
		insertArticle : function(data, onSuccess) {
			if(hui.webSQL){
				this.db.transaction(function(tx) {
					tx.executeSql('select count(id) as num from article_list where id = ?', [data.id], function(tr, result) {
						if (result.rows.item(0).num == 0) {
							tx.executeSql('INSERT into article_list values(?,?,?,?,?,?,?,?,0,1,?)', [data.id, data.title, data.img, data.ptime, data.category, data.href, parseInt(data.count, 10), data.remark, data.Androidimg], function(tx, result) {
								if (onSuccess) onSuccess(result)
							});
						}
						else onSuccess(result)
					});
				});
			}
			else if(hui.indexedDB){
				var indexdb = hui.indexedDB;
				indexdb.get({
					name: 'article_list',
					keyvalue: data.id,
					onsuccess: function(e, op){
						var result = e.target.result;
						if(result){
							onSuccess(e, op);
						}
						else{
							indexdb.add({
								name: 'article_list',
								data: data,
								onsuccess: function(e, op){
									onSuccess(e, op);
								},
								onerror: function(e, op){
									alert('insertArticle error')
								}
							});
						}
					}
				});
			}
		},

		_bind : function(type, el, bubble) {
			if(window.navigator.msPointerEnabled){
				if(type == 'touchstart'){
					el.addEventListener('MSPointerDown', this, !!bubble);
				}
				else if(type == 'touchmove'){
					el.addEventListener('MSPointerMove', this, !!bubble);
				}
				else if(type == 'touchend'){
					el.addEventListener('MSPointerUp', this, !!bubble);
				}
			}
			el.addEventListener(type, this, !!bubble);
		},
		_unbind : function(type, el, bubble) {
			if(window.navigator.msPointerEnabled){
				if(type == 'touchstart'){
					el.removeEventListener('MSPointerDown', this, !!bubble);
				}
				else if(type == 'touchmove'){
					el.removeEventListener('MSPointerMove', this, !!bubble);
				}
				else if(type == 'touchend'){
					el.removeEventListener('MSPointerUp', this, !!bubble);
				}
			}
			el.removeEventListener(type, this, !!bubble);
		},
		isIOS : function() {
			return navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/iPad/i);
		},
		isAndroid : function(t) {
			return navigator.userAgent.match(/Android/i);
		},
		androidBack : function(callback) {
			if (this.isAndroid()) {
				var win = plus.ui.getSelfWindow();
				win.addEventListener('back', callback);
			}
		},
		androidMenu : function(callback) {
			if ((/android/gi).test(navigator.appVersion)) {
				var win = plus.ui.getSelfWindow();
				win.addEventListener('menu', callback);
			}
		},
		log : function(txt) {
			plus.console.log(this.pageName + ":" + txt);
		},
		/// <summary>
		///保存文件
		/// {path:文件路径, data:要保存的文件内容, success:成功回调, error：失败回调}
		/// </summary>
		saveFile : function(options) {
			var that = this;
			that.fileSystemAPI.root.getFile(options.path, { 	
				create : true
			}, function(fileEntry) {
				//保存到临时目录
				fileEntry.createWriter(function(fileWirte) {
					fileWirte.write(JSON.stringify(options.data));
					//这个时候不存文件
					if (options.success)
						options.success();
				}, null);
			}, function(err) {
				//alert("err:" + err.code)
				if (options.error)
					options.error(err);
			});
		},
		saveArticle : function(data, articleid) {
			var that = this, path = "all_list/" + (articleid || data.id) + ".json";
			if (that.fileSystemAPI)
				that.saveFile({
					path : path,
					data : data
				});
			else
				plus.io.requestFileSystem(plus.io.PRIVATE_DOCUMENTS, function(fs) {
					that.fileSystemAPI = fs;
					that.saveFile({
						path : path,
						data : data
					});
				});
		},
		/// <summary>
		///保存文件
		/// {srcImg:源文件路径, dstImg:要保存的文件路径, success:成功回调, error：失败回调}
		/// </summary>
		downLoadFile : function(options) {
			var that = this;
			if (!that.fileSystemAPI)
				plus.io.requestFileSystem(plus.io.PRIVATE_DOCUMENTS, function(fs) {
					that.fileSystemAPI = fs;
					that._downLoadFile(options);
				});
			else
				that._downLoadFile(options);
		},
		_downLoadFile : function(options) {
			var that = this, path = options.folderPath + options.dstFile, index = path.indexOf('?');
			if (index > 0)
				path = path.substring(0, index);
//			alert('getFile:' + JSON.stringify(options));
			that.fileSystemAPI.root.getFile(path, {
				create : false
			}, function(fileEntry) {
				if (options.success)
					options.success(options, true, fileEntry);
			}, function(err) {
				if (options.onNotFund) {
					options.onNotFund(options);
					return;
				}
//				alert(options.srcFile)
				var dt = plus.downloader.createDownload(options.srcFile, {
					filename : options.downloadFolerPath,
					timeout : 120
				}, function(d, status) {
					if (status == 200) {
						d.abort();
                        //options.dFilename = d.filename;
						if (options.success)
							options.success(options, false, d);
					} else {
						if (options.error)
							options.error(options, status, d);
					}
				});
				dt.start();
			});
		},
		back: function() {
	        var currentPage = plus.ui.getSelfWindow();
	        currentPage.close('slide-out-right',300);
		},
		updateDB: function(){
			db.transaction(function(tx) {
				tx.executeSql('update article_list set Androidimg = img, readflag = 0', []);
			});
		},
		initPage: function(){
			hui.each(document.querySelectorAll("[data-icon],[data-image],[data-label],[data-count]"), function (index) {
				try{
				var t = this,
					dataicon = t.getAttribute("data-icon"),
					dataImg = t.getAttribute("data-image"),
					dataLabel = t.getAttribute("data-label"),
					dataCount = t.getAttribute("data-count");
				if (dataicon) {
					t.innerHTML = '<span class="icon ' + dataicon + '" />'
					//that.prepend()
					if (dataicon === "left") {
						t.setAttribute("href", "javascript:history.go(-1);")
					}
				}
				if (dataImg) {
					t.innerHTML = '<img src="' + dataImg + '" class="icon" />'
					//that.prepend();
				}
				if (dataLabel) {
					t.innerHTML = '<abbr>' + dataLabel + '</abbr>'
					//that.append()
				}
				if (dataCount) {
					t.innerHTML = '<span class="tag theme count">' +dataCount + '</span>'
					//that.append()
				}
				}
				catch(ex){
					hui.showErr(ex, 'initPage');
				}
			});
		},
        alert: function(message, delay) {
			var that = this,
				doc = document
				dalert = doc.getElementById('_dialog_alert');
			if(!dalert){
				dalert = doc.createElement('div');
				dalert.className = 'notification';
				dalert.id = '_dialog_alert';
				dalert.innerHTML = "<div class='window confirm growl show'><strong class='text bold' id='_dialog_message'></strong><small></small></div>";
				doc.body.appendChild(dalert);
			}
	    	if(delay==null||delay==""){
	    		delay=2000;
	    	}
			if(that._csdn_timer){
				clearTimeout(that._csdn_timer);
				//$('#_dialog_alert').remove();
			}
			doc.getElementById("_dialog_message").innerHTML = message;

			dalert.style.display = "block";
	        //$('#').show();
			dalert = null;
	        that._csdn_timer = setTimeout(function () {
	            //$('#_dialog_alert').hide();
	            doc.getElementById('_dialog_alert').style.display = 'none';
	        }, delay);
	    },
        confirm: function(message, body, icon, onAccept, onCancel) {
	        var dialogMsgBoxHTML = "<div id='_dialog_confirm' class='notification' style='display: block; '><div class='window confirm show'><span class='icon' id='_dialog_icon' ></span><strong class='text bold' id='_dialog_message'></strong><small id='_dialog_body'></small>" +
	        "<a href='#' id='_accept_btn_click' class='button anchor large text thin'>确认</a>" +
	        "<a href='#' id='_cancel_btn_click' class='button anchor large text thin'>取消</a></div></div>";
	        $("body").append(dialogMsgBoxHTML);
	        $("#_dialog_icon").addClass(icon);
	        $("#_dialog_message").html(message);
	        $("#_dialog_body").html(body);
	
	        $("#_accept_btn_click").click(function(){
	            $('#_dialog_confirm').hide();
	            $('#_dialog_confirm').remove();
	            onAccept();
	        });
	
	        $("#_cancel_btn_click").click(function(){
	            $('#_dialog_confirm').hide();
	            $('#_dialog_confirm').remove();
	            onCancel();
	        });
	
	
	        $('#_dialog_confirm').show();
	    }
	});
})(window.hui); 